Codeforces 513E2 Subarray Cuts dp (看题解)

我们肯定要一大一小间隔开来所以

把式子拆出来就是类似这样的形式 s1 - 2 * s2 + 2 * s3 + ...... + sn

然后把状态开成四个, 分别表示在顶部, 在底部, 在顶部到底部的中间, 在底部到顶部的中间。

反思一下为什么没写出来:我在考虑的时候 |s2 - s1| + |s3 - s2| + |s4 + s3| ,,, 我在想怎么把si 和 si + 1的大小关系的问题,

其实不用考虑, 因为我们求的是最大值, 所以对答案是没有影响的。

#include<bits/stdc++.h>
#define LL long long
#define LD long double
#define fi first
#define se second
#define mk make_pair
#define PLL pair<LL, LL>
#define PLI pair<LL, int>
#define PII pair<int, int>
#define SZ(x) ((int)x.size())
#define ull unsigned long long using namespace std; const int N = + ;
const int inf = 0x3f3f3f3f;
const LL INF = 0x3f3f3f3f3f3f3f3f;
const int mod = 1e9 + ;
const double eps = 1e-;
const double PI = acos(-); template<class T, class S> inline void add(T& a, S b) {a += b; if(a >= mod) a -= mod;}
template<class T, class S> inline void sub(T& a, S b) {a -= b; if(a < ) a += mod;}
template<class T, class S> inline bool chkmax(T& a, S b) {return a < b ? a = b, true : false;}
template<class T, class S> inline bool chkmin(T& a, S b) {return a > b ? a = b, true : false;} int n, K, a[N]; int dp[N][][]; int main() {
cin >> n >> K;
for(int i = ; i <= n; i++) cin >> a[i];
memset(dp, 0xc0, sizeof(dp));
for(int i = ; i <= n; i++)
for(int k = ; k < ; k++)
dp[i][][k] = ;
for(int i = ; i <= n; i++) {
for(int j = ; j <= K; j++) {
int cnt = j == || j == K ? : ;
dp[i][j][] = max(dp[i - ][j][], dp[i - ][j - ][]) - cnt * a[i];
dp[i][j][] = max(dp[i - ][j][], dp[i][j][]);
dp[i][j][] = max(dp[i - ][j][], dp[i - ][j - ][]) + cnt * a[i];
dp[i][j][] = max(dp[i - ][j][], dp[i][j][]);
if(cnt == ) {
dp[i][j][] = max(dp[i][j][], dp[i - ][j - ][]);
dp[i][j][] = max(dp[i][j][], dp[i - ][j - ][]);
}
}
}
cout << max(dp[n][K][], dp[n][K][]) << "\n";
return ;
} /*
*/
上一篇:o.a.catalina.core.AprLifecycleListener : An incompatible version [1.2.7] of the APR based Apache Tomcat Native library is installed, while Tomcat requires version [1.2.14]


下一篇:java 面试 心得